# Class RecordDeclaration

java.lang.Object
org.eclipse.jdt.core.dom.ASTNode
org.eclipse.jdt.core.dom.BodyDeclaration
org.eclipse.jdt.core.dom.AbstractTypeDeclaration
org.eclipse.jdt.core.dom.RecordDeclaration

public class RecordDeclaration extends AbstractTypeDeclaration
Record declaration AST node type (added in JLS16 API).

    RecordDeclaration:
        [ Javadoc ] { ExtendedModifier } record Identifier
                    [ < TypeParameter > ]
                    (
                    [ FormalParameter { , FormalParameter } ]
            ) { Dimension }
                    [ implements Type { , Type } ]
                    [ ; { RecordBodyDeclaration | ; } ]

The `AbstractTypeDeclaration.bodyDeclarations()` list holds the class body declarations that appear after the semicolon.

When a Javadoc comment is present, the source range begins with the first character of the "/**" comment delimiter. When there is no Javadoc comment, the source range begins with the first character of the first modifier or annotation (if present), or the first character of the "record" keyword (if no modifiers or annotations). The source range extends through the last character of the "}" token following the body declarations.

Since:
  3.26

## Field Summary

Fields
Modifier and Type
Field
Description
`static final ChildListPropertyDescriptor`
`BODY_DECLARATIONS_PROPERTY`
The "bodyDeclarations" structural property of this node type (element type: `BodyDeclaration`).
`static final ChildPropertyDescriptor`
`JAVADOC_PROPERTY`
The "javadoc" structural property of this node type (child type: `Javadoc`).
`static final ChildListPropertyDescriptor`
`MODIFIERS2_PROPERTY`
The "modifiers" structural property of this node type (element type: `IExtendedModifier`).
`static final ChildPropertyDescriptor`
`NAME_PROPERTY`
The "name" structural property of this node type (child type: `SimpleName`).
`static final ChildListPropertyDescriptor`
`RECORD_COMPONENTS_PROPERTY`
The "recordComponents" structural property of this node type (element type: `SingleVariableDeclaration`).
`static final ChildListPropertyDescriptor`
`SUPER_INTERFACE_TYPES_PROPERTY`
The "superInterfaceTypes" structural property of this node type (element type: `Type`).
`static final ChildListPropertyDescriptor`
`TYPE_PARAMETERS_PROPERTY`
The "typeParameters" structural property of this node type (element type: `TypeParameter`).

### Fields inherited from class ASTNode

`ANNOTATION_TYPE_DECLARATION, ANNOTATION_TYPE_MEMBER_DECLARATION, ANONYMOUS_CLASS_DECLARATION, ARRAY_ACCESS, ARRAY_CREATION, ARRAY_INITIALIZER, ARRAY_TYPE, ASSERT_STATEMENT, ASSIGNMENT, BLOCK, BLOCK_COMMENT, BOOLEAN_LITERAL, BREAK_STATEMENT, CASE_DEFAULT_EXPRESSION, CAST_EXPRESSION, CATCH_CLAUSE, CHARACTER_LITERAL, CLASS_INSTANCE_CREATION, COMPILATION_UNIT, CONDITIONAL_EXPRESSION, CONSTRUCTOR_INVOCATION, CONTINUE_STATEMENT, CREATION_REFERENCE, DIMENSION, DO_STATEMENT, EitherOr_MultiPattern, EMPTY_STATEMENT, ENHANCED_FOR_STATEMENT, ENUM_CONSTANT_DECLARATION, ENUM_DECLARATION, EXPORTS_DIRECTIVE, EXPRESSION_METHOD_REFERENCE, EXPRESSION_STATEMENT, FIELD_ACCESS, FIELD_DECLARATION, FOR_STATEMENT, GUARDED_PATTERN, IF_STATEMENT, IMPORT_DECLARATION, INFIX_EXPRESSION, INITIALIZER, INSTANCEOF_EXPRESSION, INTERSECTION_TYPE, JAVADOC, JAVADOC_REGION, JAVADOC_TEXT_ELEMENT, LABELED_STATEMENT, LAMBDA_EXPRESSION, LINE_COMMENT, MALFORMED, MARKER_ANNOTATION, MEMBER_REF, MEMBER_VALUE_PAIR, METHOD_DECLARATION, METHOD_INVOCATION, METHOD_REF, METHOD_REF_PARAMETER, MODIFIER, MODULE_DECLARATION, MODULE_MODIFIER, MODULE_QUALIFIED_NAME, NAME_QUALIFIED_TYPE, NORMAL_ANNOTATION, NULL_LITERAL, NULL_PATTERN, NUMBER_LITERAL, OPENS_DIRECTIVE, ORIGINAL, PACKAGE_DECLARATION, PARAMETERIZED_TYPE, PARENTHESIZED_EXPRESSION, PATTERN_INSTANCEOF_EXPRESSION, POSTFIX_EXPRESSION, PREFIX_EXPRESSION, PRIMITIVE_TYPE, PROTECT, PROVIDES_DIRECTIVE, QUALIFIED_NAME, QUALIFIED_TYPE, RECORD_DECLARATION, RECORD_PATTERN, RECOVERED, REQUIRES_DIRECTIVE, RETURN_STATEMENT, SIMPLE_NAME, SIMPLE_TYPE, SINGLE_MEMBER_ANNOTATION, SINGLE_VARIABLE_DECLARATION, STRING_LITERAL, SUPER_CONSTRUCTOR_INVOCATION, SUPER_FIELD_ACCESS, SUPER_METHOD_INVOCATION, SUPER_METHOD_REFERENCE, SWITCH_CASE, SWITCH_EXPRESSION, SWITCH_STATEMENT, SYNCHRONIZED_STATEMENT, TAG_ELEMENT, TAG_PROPERTY, TEXT_BLOCK, TEXT_ELEMENT, THIS_EXPRESSION, THROW_STATEMENT, TRY_STATEMENT, TYPE_DECLARATION, TYPE_DECLARATION_STATEMENT, TYPE_LITERAL, TYPE_METHOD_REFERENCE, TYPE_PARAMETER, TYPE_PATTERN, UNION_TYPE, UNNAMED_CLASS, USES_DIRECTIVE, VARIABLE_DECLARATION_EXPRESSION, VARIABLE_DECLARATION_FRAGMENT, VARIABLE_DECLARATION_STATEMENT, WHILE_STATEMENT, WILDCARD_TYPE, YIELD_STATEMENT`

## Method Summary

Modifier and Type
Method
Description
`FieldDeclaration[]`
`getFields()`
Returns the ordered list of field declarations of this type declaration.
`MethodDeclaration[]`
`getMethods()`
Returns the ordered list of method declarations of this type declaration.
`int`
`getRestrictedIdentifierStartPosition()`
`static List`
`propertyDescriptors(int apiLevel)`
Returns a list of structural property descriptors for this node type.
`List`
`recordComponents()`
Returns the live ordered list of recordComponents of record declaration.
`void`
`setRestrictedIdentifierStartPosition(int restrictedIdentifierStartPosition)`
`List`
`superInterfaceTypes()`
Returns the live ordered list of superinterfaces of this type declaration (added in JLS3 API).
`List`
`typeParameters()`
Returns the live ordered list of type parameters of this type declaration (added in JLS3 API).

### Methods inherited from class AbstractTypeDeclaration

`bodyDeclarations, getBodyDeclarationsProperty, getName, getNameProperty, isLocalTypeDeclaration, isMemberTypeDeclaration, isPackageMemberTypeDeclaration, resolveBinding, setName`

### Methods inherited from class BodyDeclaration

`getJavadoc, getJavadocProperty, getModifiers, getModifiersProperty, modifiers, setJavadoc, setModifiers`

### Methods inherited from class ASTNode

`accept, copySubtree, copySubtrees, delete, equals, getAST, getFlags, getLength, getLocationInParent, getNodeType, getParent, getProperty, getRoot, getStartPosition, getStructuralProperty, hashCode, nodeClassForType, properties, setFlags, setProperty, setSourceRange, setStructuralProperty, structuralPropertiesForType, subtreeBytes, subtreeMatch, toString`

### Methods inherited from class Object

`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

## Field Details

### JAVADOC_PROPERTY

public static final ChildPropertyDescriptor JAVADOC_PROPERTY
The "javadoc" structural property of this node type (child type: `Javadoc`).

### MODIFIERS2_PROPERTY

public static final ChildListPropertyDescriptor MODIFIERS2_PROPERTY
The "modifiers" structural property of this node type (element type: `IExtendedModifier`).

### NAME_PROPERTY

public static final ChildPropertyDescriptor NAME_PROPERTY
The "name" structural property of this node type (child type: `SimpleName`).

### SUPER_INTERFACE_TYPES_PROPERTY

public static final ChildListPropertyDescriptor SUPER_INTERFACE_TYPES_PROPERTY
The "superInterfaceTypes" structural property of this node type (element type: `Type`).

### TYPE_PARAMETERS_PROPERTY

public static final ChildListPropertyDescriptor TYPE_PARAMETERS_PROPERTY
The "typeParameters" structural property of this node type (element type: `TypeParameter`).

### RECORD_COMPONENTS_PROPERTY

public static final ChildListPropertyDescriptor RECORD_COMPONENTS_PROPERTY
The "recordComponents" structural property of this node type (element type: `SingleVariableDeclaration`).

### BODY_DECLARATIONS_PROPERTY

public static final ChildListPropertyDescriptor BODY_DECLARATIONS_PROPERTY
The "bodyDeclarations" structural property of this node type (element type: `BodyDeclaration`).

## Method Details

### setRestrictedIdentifierStartPosition

public void setRestrictedIdentifierStartPosition(int restrictedIdentifierStartPosition)

Since:
  3.26

### getRestrictedIdentifierStartPosition

public int getRestrictedIdentifierStartPosition()

Returns:
  restrictedIdentifierStartPosition
Since:
  3.26

### propertyDescriptors

public static List propertyDescriptors(int apiLevel)
Returns a list of structural property descriptors for this node type. Clients must not modify the result.

Parameters:
  `apiLevel` - the API level; one of the `AST.JLS*` constants
Returns:
  a list of property descriptors (element type: `StructuralPropertyDescriptor`)
Since:
  3.26

### typeParameters

public List typeParameters()
Returns the live ordered list of type parameters of this type declaration (added in JLS3 API). This list is non-empty for parameterized types.

Returns:
  the live list of type parameters (element type: `TypeParameter`)
Since:
  3.26

### superInterfaceTypes

public List superInterfaceTypes()
Returns the live ordered list of superinterfaces of this type declaration (added in JLS3 API). For a class declaration, these are the interfaces that this class implements; for an interface declaration, these are the interfaces that this interface extends.

Returns:
  the live list of interface types (element type: `Type`)
Since:
  3.26

### recordComponents

public List recordComponents()
Returns the live ordered list of recordComponents of record declaration.

Returns:
  the live list of recordComponents (element type: `SingleVariableDeclaration`)
Since:
  3.26

### getFields

public FieldDeclaration[] getFields()
Returns the ordered list of field declarations of this type declaration. For a class declaration, these are the field declarations; for an interface declaration, these are the constant declarations.

This convenience method returns this node's body declarations with non-fields filtered out. Unlike `bodyDeclarations`, this method does not return a live result.

Returns:
  the (possibly empty) list of field declarations
Since:
  3.26

### getMethods

public MethodDeclaration[] getMethods()
Returns the ordered list of method declarations of this type declaration.

This convenience method returns this node's body declarations with non-methods filtered out. Unlike `bodyDeclarations`, this method does not return a live result.

Returns:
  the (possibly empty) list of method (and constructor) declarations
Since:
  3.26